=== debian/changelog ===
persalys (13.1.1+ds-1) unstable; urgency=medium

  * New upstream version 13.1.1+ds
  * Raising Standards version to 4.6.2 (no change)
  * Removing all patches, which have been upstreamed
  * Changing the path of generated Python files for the install step
  * Hardening
  * Correcting a minor spelling error

 -- Pierre Gruet <pgt@debian.org>  Tue, 20 Dec 2022 09:16:14 +0100

persalys (12.0.1+ds-3) unstable; urgency=medium

  * Running the tests with xvfb-run to avoid skipping X11-dependent tests
  * Simplifying d/rules
  * Comparing doubles by testing if the absolute value of their difference is
    small, instead of using ==
  * Set upstream metadata fields: Repository.
  * Conforming to the openturns 1.20 ABI

 -- Pierre Gruet <pgt@debian.org>  Sat, 26 Nov 2022 07:18:29 +0100
